<?php

namespace HCM\FPA\Calculos\Geral;

use HCM\FPA\Calculos\Geral\TeknisaAbstractRegra;
use HCM\Util\DateUtil;

class TeknisaRegra extends TeknisaAbstractRegra {

    public function __construct($evaluator){
        parent::__construct($evaluator);

    }

    public function retornaMaiorValor ($valor_1, $valor_2){
        $valor = max($valor_1, $valor_2);
        return $valor;
    }

    public function retornaMenorValor ($valor_1, $valor_2){
        $valor = min($valor_1, $valor_2);
        return $valor;
    }

    public function comparaValores($valor_1, $operador, $valor_2){
        $resultado = false;

        $operacao = 'if ('.$valor_1.' '.$operador.' '.$valor_2.') {';
        $operacao .= '$resultado = true; }';

        eval($operacao);

        return $resultado;
    }
    
    public function retornaDataPorParte($data, $tipo){
        $data = DateUtil::getDataDeString($data);

        if ($tipo === 'Y' || $tipo === 'A') {
            $valor = $data->format('Y');
        } else if ($tipo === 'M') {
            $valor = $data->format('m');
        } else if ($tipo === 'D') {
            $valor = $data->format('d');
        }
        
        return $valor;
    }

    public function retornaDiferencaDatas($data_1, $data_2, $tipo){
        $data_1 = DateUtil::getDataDeString($data_1);
        $data_2 = DateUtil::getDataDeString($data_2);

        if ($tipo === 'Y' || $tipo === 'A') {
            $valor = DateUtil::getQtdeAnosEntre($data_1, $data_2);
        } else if ($tipo === 'M') {
            $valor = DateUtil::getQtdeMesesEntre($data_1, $data_2);
        } else if ($tipo === 'D') {
            $valor = DateUtil::getQtdeDiasEntre($data_1, $data_2) + 1;
        }
        
        return abs($valor);
    }

    public function retornaValorAleatorio($limiteMin, $limiteMax){
        $valor = rand($limiteMin, $limiteMax);
        return $valor;
    }
}