<?php
namespace HCM\AVL\Services;

use Doctrine\ORM\EntityManager;
use HCM\Util\Messages;
use HCM\Util\Repositories;

class NivelAvaliacaoService {
    
    protected $nivelavaliacaoRepository;

    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
    
     public function getQuestaoAvaliacao($dataset) {
        return $this->entityManager->getRepository(Repositories::NIVELQUESTAVAL)->findBy(array("nrorg" => $dataset['NRORG'], "nrnivelavalia" => $dataset["NRNIVELAVALIA"]));
    }
    
}
