<?php

namespace HCM\FPA\ObrigacaoLegal\Manad\Blocos\Registros;

use HCM\FPA\ObrigacaoLegal\Manad\Blocos\Registros\Registro0000;

class RegistroK050 extends Registro0000 {

    private $_cnpjCei;
    private $_dtIncAlt;
    private $_regTrab;
    private $_cpf;
    private $_nit;
    private $_categ;
    private $_nome;
    private $_dtNasc;
    private $_dtAdm;
    private $_dtDem;
    private $_indVinc;
    private $_tpAtoNom;
    private $_nrAtoNom;
    private $_dtAtoNom;

    public function geraRegistroK050(){
        $this->_geraRegistro(self::REGISTRO_K050);
    }

    private function _geraRegistro($tpRegistro){
        // Ordem 1
        $this->atribuiDadoManad($tpRegistro);
        // Ordem 2
        $this->atribuiDadoManad($this->_cnpjCei);
        // Ordem 3
        $this->atribuiDadoManad($this->_dtIncAlt);
        // Ordem 4
        $this->atribuiDadoManad($this->_regTrab);
        // Ordem 5
        $this->atribuiDadoManad($this->_cpf);
        // Ordem 6
        $this->atribuiDadoManad($this->_nit);
        // Ordem 7
        $this->atribuiDadoManad($this->_categ);
        // Ordem 8
        $this->atribuiDadoManad($this->_nome);
        // Ordem 9
        $this->atribuiDadoManad($this->_dtNasc);
        // Ordem 10
        $this->atribuiDadoManad($this->_dtAdm);
        // Ordem 11
        $this->atribuiDadoManad($this->_dtDem);
        // Ordem 12
        $this->atribuiDadoManad($this->_indVinc);
        // Ordem 13
        $this->atribuiDadoManad($this->_tpAtoNom);
        // Ordem 14
        $this->atribuiDadoManad($this->_nrAtoNom);
        // Ordem 15
        $this->atribuiDadoManad($this->_dtAtoNom, true);
    }
    
    public function setCnpjCei($cnpjCei){
        $this->_cnpjCei = $cnpjCei;
    }
    public function setDtIncAlt($dtIncAlt){
        $this->_dtIncAlt = $dtIncAlt;
    }
    public function setRegTrab($regTrab){
        $this->_regTrab = $regTrab;
    }
    public function setCpf($cpf){
        $this->_cpf = $cpf;
    }
    public function setNit($nit){
        $this->_nit = $nit;
    }
    public function setCateg($categ){
        $this->_categ = $categ;
    }
    public function setNome($nome){
        $this->_nome = $nome;
    }
    public function setDtNasc($dtNasc){
        $this->_dtNasc = $dtNasc;
    }
    public function setDtAdm($dtAdm){
        $this->_dtAdm = $dtAdm;
    }
    public function setDtDem($dtDem){
        $this->_dtDem = $dtDem;
    }
    public function setIndVinc($indVinc){
        $this->_indVinc = $indVinc;
    }
    public function setTpAtoNom($tpAtoNom){
        $this->_tpAtoNom = $tpAtoNom;
    }
    public function setNrAtoNom($nrAtoNom){
        $this->_nrAtoNom = $nrAtoNom;
    }
    public function setDtAtoNom($dtAtoNom){
        $this->_dtAtoNom = $dtAtoNom;
    }
}