 /*
--TIPOS DE ESTRUTURAS 
  V_CENTRODECUSTO    NUMBER := 5;
  V_DEPARTAMENTO     NUMBER := 3;
  V_PROJETO          NUMBER := 9;
  V_SECAO            NUMBER := 11;
  V_TOMADOR          NUMBER := 7;
  V_EMPRESA          NUMBER := 1;
  V_FILIAL           NUMBER := 2;
  V_REGIAO           NUMBER := 8;
  V_SETOR            NUMBER := 4;
  V_PRODUTO          NUMBER := 12;
  V_SINDICATO        NUMBER := 10;
  V_PLANOSAUDE       NUMBER := 13;
  
-- VALORES PARA MOVIMENTAES DE ESTRUTURAS
  V_MOV_LEGAL        NUMBER := 1;
  V_MOV_GEREN        NUMBER := 2;
  V_MOTIVO_TRANS_ADM NUMBER := 2;
  V_MOTIVO_TRANS_ENT NUMBER := 8;
  V_MOTIVO_TRANS_GER NUMBER := 12;
 */ 


--CONTA QUANTIDADE MOVIMENTACOES DE ESTRUTURA =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
--Tabelas: RHALTERACOESCONTRATO, RHCONTRATOS
--Leiaute 12 - Movimentao de Estruturas
--V1 - 18/10/2023 
--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
  

  SELECT COUNT(1) TOTAL
                FROM RHALTERACOESCONTRATO
                JOIN RHCONTRATOS
                  ON RHCONTRATOS.CONTRATO = RHALTERACOESCONTRATO.CONTRATO
                 AND RHCONTRATOS.UNIDADE  = RHALTERACOESCONTRATO.UNIDADE
               WHERE RHALTERACOESCONTRATO.VARIAVEL in  ('CCC1','CCC2','CEST','CPOS','CUNI','CSIN');

               
--GERA LEIAUTE MOVIMENTACOES DE ESTRUTURA -=-==-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
--Tabelas: RHALTERACOESCONTRATO, RHCONTRATOS
--Leiaute 12 - Movimentao de Estruturas
--V1 - 18/10/2023 
--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
            
             SELECT DISTINCT 
                EMPRESA||'_'||CONTRATO                                          AS "Nr Vnculo",                                
                CASE WHEN VARIAVEL IN('CCC1','CCC2','CPOS','CUNI') THEN 2
                     WHEN VARIAVEL IN('CEST','CSIN') THEN 1
                END                                                             AS "Nr Tipo Transferncia",
                
                MOTIVOTRANSFERENCIA                                             AS "Nr Motivo Transferncia",                
                
                CASE    
                    WHEN VARIAVEL IN('CCC1') THEN '1CC'||CODIGOANTERIOR
                    WHEN VARIAVEL IN('CCC2') THEN '2CC'||CODIGOANTERIOR
                    WHEN VARIAVEL IN('CPOS') THEN 'POS'||CODIGOANTERIOR
                    WHEN VARIAVEL IN('CUNI') THEN 'UNI'||CODIGOANTERIOR
                    WHEN VARIAVEL IN('CEST') THEN 'EST'||CODIGOANTERIOR
                    WHEN VARIAVEL IN('CSIN') THEN 'SIN'||CODIGOANTERIOR
                END                                                             AS "Nr Estrutura",
                
                ''                                                              AS "Observao",                
                
                ''                                                              AS "Dt Fim Movimentao",
                
                TO_CHAR(DATAADMISSAO,'DD/MM/YYYY')                              AS "Dt Incio Movimentao", 
                CASE    
                    WHEN VARIAVEL IN('CCC1') THEN '121'
                    WHEN VARIAVEL IN('CCC2') THEN '5'
                    WHEN VARIAVEL IN('CPOS') THEN '119'
                    WHEN VARIAVEL IN('CUNI') THEN '120'
                    WHEN VARIAVEL IN('CEST') THEN '20'
                    WHEN VARIAVEL IN('CSIN') THEN '10'
                END                                                             AS "Nr Tipo Estrutura",
                ''                                                              AS "Dt Mov Retroativa",
                ''                                                              AS "Motivo da Transferncia"
              FROM (SELECT ROW_NUMBER() OVER(PARTITION BY RHALTERACOESCONTRATO.CONTRATO ORDER BY RHALTERACOESCONTRATO.CONTRATO, DATAHORAALTERACAO) AS SEQUENCIAL, 
                           RHCONTRATOS.CONTRATO, RHCONTRATOS.EMPRESA, RHCONTRATOS.PESSOA, RHCONTRATOS.DATAADMISSAO, DATAHORAALTERACAO, VARIAVEL, CODIGOANTERIOR, CODIGOATUAL, CONTEUDOANTERIOR, CONTEUDOATUAL,
                           '2' AS MOTIVOTRANSFERENCIA
                      FROM RHALTERACOESCONTRATO
                      JOIN RHCONTRATOS
                        ON RHCONTRATOS.CONTRATO = RHALTERACOESCONTRATO.CONTRATO
                       AND RHCONTRATOS.UNIDADE  = RHALTERACOESCONTRATO.UNIDADE
                     WHERE RHALTERACOESCONTRATO.VARIAVEL IN ('CCC1','CCC2','CEST','CPOS','CUNI','CSIN') 
                     AND (rhcontratos.causarescisaofolha<>6 or rhcontratos.causarescisaofolha is null )
                     AND CODIGOANTERIOR IS NOT NULL
                     ORDER BY RHALTERACOESCONTRATO.CONTRATO, DATAHORAALTERACAO) ALTERACOES
             WHERE SEQUENCIAL = 1 
             
            UNION ALL
                        
            SELECT DISTINCT RHCONTRATOS.EMPRESA||'__'||RHCONTRATOS.CONTRATO     AS "Nr Vnculo",  
                CASE WHEN VARIAVEL IN('CCC1','CCC2','CPOS','CUNI') THEN 2
                     WHEN VARIAVEL IN('CEST','CSIN') THEN 1
                END                                                             AS "Nr Tipo Transferncia",
                
                '2'                                                             AS "Nr Motivo Transferncia",
                CASE    
                    WHEN VARIAVEL IN('CCC1') THEN '1CC'||CODIGOATUAL
                    WHEN VARIAVEL IN('CCC2') THEN '2CC'||CODIGOATUAL
                    WHEN VARIAVEL IN('CPOS') THEN 'POS'||CODIGOATUAL
                    WHEN VARIAVEL IN('CUNI') THEN 'UNI'||CODIGOATUAL
                    WHEN VARIAVEL IN('CEST') THEN 'EST'||CODIGOATUAL
                    WHEN VARIAVEL IN('CSIN') THEN 'SIN'||CODIGOATUAL
                END                                                             AS "Nr Estrutura",
                ''                                                              AS "Observao",                
                
                ''                                                              AS "Dt Fim Movimentao",
                 TO_CHAR(DATAHORAALTERACAO,'DD/MM/YYYY')                        AS "Dt Incio Movimentao",
                CASE    
                    WHEN VARIAVEL IN('CCC1') THEN '121'
                    WHEN VARIAVEL IN('CCC2') THEN '5'
                    WHEN VARIAVEL IN('CPOS') THEN '119'
                    WHEN VARIAVEL IN('CUNI') THEN '120'
                    WHEN VARIAVEL IN('CEST') THEN '20'
                    WHEN VARIAVEL IN('CSIN') THEN '10'
                END                                                             AS "Nr Tipo Estrutura",
                ''                                                              AS "Dt Mov Retroativa",
                ''                                                              AS "Motivo da Transferncia"                
              FROM RHALTERACOESCONTRATO
              JOIN RHCONTRATOS
                ON RHCONTRATOS.CONTRATO = RHALTERACOESCONTRATO.CONTRATO
               AND RHCONTRATOS.UNIDADE  = RHALTERACOESCONTRATO.UNIDADE
             WHERE RHALTERACOESCONTRATO.VARIAVEL IN ('CCC1','CCC2','CEST','CPOS','CUNI','CSIN')
             AND (rhcontratos.causarescisaofolha<>6 or rhcontratos.causarescisaofolha is null )
              AND CODIGOATUAL IS NOT NULL;